package org.nuiton.topia.test.ano1882;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.nuiton.topia.TopiaException;
import org.nuiton.topia.TopiaTestDAOHelper.TopiaTestEntityEnum;
import org.nuiton.topia.persistence.TopiaDAOImpl;
import org.nuiton.topia.persistence.TopiaEntity;

public abstract class SIRENDAOAbstract<E extends SIREN> extends TopiaDAOImpl<E> {

    @Override
    public Class<E> getEntityClass() {
        return (Class<E>)SIREN.class;
    }

    @Override
    public TopiaTestEntityEnum getTopiaEntityEnum() {
        return TopiaTestEntityEnum.SIREN;
    }

    @Override
    public void delete(E entity) throws TopiaException {
                                        {
                                        List<FrenchCompany> list = getContext()
                                                    .getDAO(FrenchCompany.class)
                                                    .findAllByProperties(FrenchCompany.PROPERTY_S_IREN, entity);
                                            for (FrenchCompany item : list) {

                                                // sletellier : Set null only if target is concerned by deletion
                                                if (entity.equals(item.getsIREN())) {
                                                    item.setsIREN(null);
                                                }
                        
                    }
                }

                                        {
                                        List<FrenchCompany> list = getContext()
                                                    .getDAO(FrenchCompany.class)
                                                    .findAllByProperties(FrenchCompany.PROPERTY_SIREN2, entity);
                                            for (FrenchCompany item : list) {

                                                // sletellier : Set null only if target is concerned by deletion
                                                if (entity.equals(item.getSIREN2())) {
                                                    item.setSIREN2(null);
                                                }
                        
                    }
                }

        super.delete(entity);
    }

    @Override
    public <U extends TopiaEntity> List<U> findUsages(Class<U> type, E entity) throws TopiaException {
        List<?> result = new ArrayList();
        List tmp;

        if (type == FrenchCompany.class) {
            FrenchCompanyDAO dao = (FrenchCompanyDAO)
                getContext().getDAO(FrenchCompany.class);
            tmp = dao.findAllBysIREN(entity);
            result.addAll(tmp);
        }

        if (type == FrenchCompany.class) {
            FrenchCompanyDAO dao = (FrenchCompanyDAO)
                getContext().getDAO(FrenchCompany.class);
            tmp = dao.findAllBySIREN2(entity);
            result.addAll(tmp);
        }

        return (List<U>) result;
    }

    @Override
    public Map<Class<? extends TopiaEntity>, List<? extends TopiaEntity>> findAllUsages(E entity) throws TopiaException {
        Map<Class<? extends TopiaEntity>,List<? extends TopiaEntity>> result;
        result = new HashMap<Class<? extends TopiaEntity>, List<? extends TopiaEntity>>(1);

        List<? extends TopiaEntity> list;

        list = findUsages(FrenchCompany.class, entity);
        if (!list.isEmpty()) {
            result.put(FrenchCompany.class, list);
        }

        return result;
    }

} //SIRENDAOAbstract<E extends SIREN>
